from ngsolve import *
from netgen.geom2d import unit_square

mesh = Mesh(unit_square.GenerateMesh(maxh=0.1))

fes = H1(mesh, order=1)
gfu = GridFunction(fes)

gfu.Set(x*y+2*y)
Draw(gfu, mesh, "gfu")

limit = 1.5

dofs = BitArray(fes.ndof)
dofs[:] = False
for i in range(fes.ndof):
    if gfu.vec[i] > limit:
        dofs[i] = True
        
print("dofs = \n", dofs)
gf_dof = GridFunction(fes)
for i in range(fes.ndof):
    gf_dof.vec[i] = dofs[i]
Draw(gf_dof,mesh, "gf_dof")


fes2 = H1(mesh, order=1, dirichlet="left|top|bottom|right")
print("ndof before = ", fes2.ndof)
for i in range(fes.ndof):
    if dofs[i] == False:
        fes2.SetCouplingType(i,COUPLING_TYPE.UNUSED_DOF)
fes2 = Compress(fes2)
print("ndof after = ", fes2.ndof)

gfu2 = GridFunction(fes2)
gfu2.Set(y)
Draw(gfu2, mesh, "gfu2")
